SystemOrganization addCategory: #'VMs-Seminar'!

Interpreter subclass: #NoMethodCacheInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMs-Seminar'!

!NoMethodCacheInterpreter methodsFor: 'method lookup cache' stamp: 'ag 1/19/2014 17:04'!
addNewMethodToCache
	"Method cache disabled."
	
	<inline: false>
	self compilerTranslateMethodHook.	"newMethod x lkupClass -> newNativeMethod (may cause GC !!)"
	primitiveFunctionPointer := self functionPointerFor: primitiveIndex inClass: lkupClass.! !

!NoMethodCacheInterpreter methodsFor: 'method lookup cache' stamp: 'ag 1/19/2014 17:04'!
lookupInMethodCacheSel: selector class: class
	"Lookup Cache disabled."
	
	<inline>
	^ false! !

Interpreter subclass: #VeryLongJumpInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMs-Seminar'!

VeryLongJumpInterpreter subclass: #PLCInterpreter
	instanceVariableNames: 'syntheticMessageSend'
	classVariableNames: 'DebugPLC PlcCompiledMethodIndex PlcEntries PlcFirstEntryIndex PlcLkupClassIndex PlcMessageSelectorIndex PlcMetaInfoEntries PlcNewMethodIndex PlcNewNativeMethodIndex PlcPrimitiveIndex PlcUseMethodLookupCache PointersPerPlcEntry'
	poolDictionaries: ''
	category: 'VMs-Seminar'!

!PLCInterpreter commentStamp: '<historical>' prior: 0!
This class is a complete implementation of the Smalltalk-80 virtual machine, derived originally from the Blue Book specification but quite different in some areas.

It has been modernized with 32-bit pointers, better management of Contexts, and attention to variable use that allows the CCodeGenerator (qv) to keep, eg, the instruction pointer and stack pointer in registers as well as keeping most simple variables in a global array that seems to improve performance for most platforms.

In addition to SmallInteger arithmetic and Floats, it supports logic on 32-bit PositiveLargeIntegers, thus allowing it to simulate itself much more effectively than would otherwise be the case.

NOTE:  Here follows a list of things to be borne in mind when working on this code, or when making changes for the future.

1.  There are a number of things that should be done the next time we plan to release a copletely incompatible image format.  These include unifying the instanceSize field of the class format word -- see instantiateClass:indexableSize:, and unifying the bits of the method primitive index (if we decide we need more than 512, after all

----STARTUP----{10 December 2013 . 3:43:28 pm} as /home/anton/shared/squeak/Squeak4.3.image!

!PLCInterpreter class methodsFor: 'initialization' stamp: 'ag 1/15/2014 09:49'!
initialize
	
	super initialize.
	self initializePLC.! !

!PLCInterpreter class methodsFor: 'translation' stamp: 'ag 1/15/2014 09:54'!
initializeClassicObjectMemoryInCodeGenerator: cg
	"Copied from initializeClassicObjectMemoryInCodeGenerator:
	This is hacky, but saw no other way without adding ObjectMemory multiple times."
	
	cg addClass: PLCObjectMemory upTo: VMClass asInstanceVariable: #objectMemory.
	"references from ObjectMemory to #interpreter are local functions in generated code"
	^cg mapVar: #interpreter asInstanceOf: PLCObjectMemory to: 'self'! !

!PLCInterpreter class methodsFor: 'initialization' stamp: 'ag 1/20/2014 16:43'!
initializePLC
	
	DebugPLC := false.
	PlcUseMethodLookupCache := false.
	
	PlcEntries := PLCStruct defaultNumberOfEntries.
	PointersPerPlcEntry := PLCStruct pointersPerEntry.
	
	PlcMetaInfoEntries := PLCStruct metaInfoEntries.
	PlcFirstEntryIndex := PlcMetaInfoEntries.
	PlcMessageSelectorIndex := PLCStruct messageSelectorIndex - 1.
	PlcCompiledMethodIndex := PLCStruct compiledMethodIndex - 1.
	
	PlcLkupClassIndex := 0.
	PlcNewMethodIndex := 1.
	PlcPrimitiveIndex := 2.
	PlcNewNativeMethodIndex := 3.
	
	PLCObjectMemory initializeSpecialObjectIndices.! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/20/2014 14:46'!
addToPLC: plc
	"Linear search over the contents of the PLCStruct until an empty spot is found.
	Return false if the PLCStruct was already full.
	C compiler should unroll constant loop."
	
	"TODO - Handle the already-full condition by invalidating a value or growing the PLC."
	
	<inline: true>
	| index |
	index := self indexOfClass: objectMemory nilObj inPLC: plc.
	index = 0 ifTrue: [
		self debugFullPLC: plc.
		^ false ].
	self storeIntoPlc: plc index: index.
	^ true! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/20/2014 20:43'!
checkCorrectClassOf: plc at: plcIndex
	
	self isInDebuggedMethod ifFalse: [ ^ true ].
	(objectMemory fetchClassOf: plc) == objectMemory classPLCStruct
		ifFalse: [
			self print: 'Wrong class of plc object for '.
			self printStringOf: messageSelector.
			self print: ' at index '.
			self printNum: plcIndex.
			self print: ' inside method '.
			self printStringOf: (self selectorOfMethod: method).
			self cr.
			^ false ].
	^ true! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/20/2014 20:43'!
checkOkayOop: oop
	
	<inline: false>
	self isInDebuggedMethod ifFalse: [ ^ nil ].
	objectMemory okayOop: oop.
	self oopHasOkayClass: oop.! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/20/2014 20:43'!
checkOkayPLC: plc
	
	<inline: false>
	self isInDebuggedMethod ifFalse: [ ^ nil ].
	self print: ' > Checking consistency of PLC entries .. '.
	0 to: self plcSize - 1 do: [ :i |
		self printNum: i. self print: ' .. '.
		objectMemory checkOkayOop: (objectMemory fetchPointer: i ofObject: plc)
	].
	self cr.! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/20/2014 18:48'!
checkString: stString equals: cString
	"Mostly copied from #classNameOf:Is:"
	
	<inline: false>
	<var: #cString type: 'char *'>
	<var: #arr type: 'char *'>
	| length arr |
	(objectMemory isBytes: stString) ifFalse: [^ false].
	length := self stSizeOf: stString.
	arr := self cCoerce: (self arrayValueOf: stString) to: 'char *'.
	0 to: length - 1 do: [:i | (cString at: i) = (arr at: i) ifFalse: [^ false]].
	"Check if cString really ends at this point"
	^ (cString at: length) = 0! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/18/2014 00:06'!
classNameOf: aClass
	
	^ objectMemory fetchPointer: 6 ofObject: aClass! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/19/2014 15:03'!
createNewPLCAt: plcIndex
	
	| plc |
	plc := self instantiatePLC.
	plc storePointer: PlcMessageSelectorIndex ofObject: plc withValue: messageSelector.
	plc storePointer: PlcCompiledMethodIndex ofObject: plc withValue: method.
	self literal: plcIndex ofMethod: method store: plc.
	self storeIntoPlc: plc index: PlcFirstEntryIndex. "Offset for storing selector"! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/20/2014 20:43'!
debugFullPLC: plc
	
	<inline: false>
	self isInDebuggedMethod ifFalse: [ ^ nil ].
	self print: 'PLC is full!! '.
	self printPLC: plc.
	self cr.! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/20/2014 20:43'!
debugPLC: plc atIndex: index
	
	<inline: false>
	self isInDebuggedMethod ifFalse: [ ^ nil ].
	self printPLC: plc atIndex: index.
	self cr.! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/20/2014 20:43'!
debugRestoredFrom: plc index: index
	
	<inline: false>
	self isInDebuggedMethod ifFalse: [ ^ nil ].
	self print: ' > Restored from PLC. '.
	self printCacheEntry: index of: plc.
	self cr.! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/20/2014 20:43'!
debugStoredInto: plc index: index
	
	<inline: false>
	self isInDebuggedMethod ifFalse: [ ^ nil ].
	self print: ' > Stored into PLC. '.
	self printCacheEntry: index of: plc.
	self cr.! !

!PLCInterpreter methodsFor: 'message sending' stamp: 'ag 1/20/2014 17:22'!
doMethodLookup
	"Small configurable optimization: instead of doing just the regular lookup, use the method lookup cache.
	If disabled, just do the regular method lookup."
	
	PlcUseMethodLookupCache
		ifTrue: [	super internalFindNewMethod ]
		ifFalse: [
			self externalizeIPandSP.
			self lookupMethodInClass: lkupClass.
			self internalizeIPandSP.
			self compilerTranslateMethodHook.
			self setPrimitiveFunctionPointer: primitiveIndex ].! !

!PLCInterpreter methodsFor: 'compiled methods' stamp: 'ag 1/13/2014 17:52'!
flagBitOf: aMethod
	
	<inline: true>
	^ ((self headerOf: aMethod) >> 30) bitAnd: 16r1! !

!PLCInterpreter methodsFor: 'message sending' stamp: 'ag 1/16/2014 15:21'!
handlingPLCMethod
	"Check if the currently executed CompiledMethod has the flag-bit set."
	
	<inline: true>
	^ objectMemory hasPLCStruct and: [ self flagBitOf: method ]! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/19/2014 15:04'!
indexOfClass: class inPLC: plc
	"Iterate the class-slots in plc and return the index of class, if found. Return 0 otherwise.
	0 cannot be the index of any class, because the selector is stored at index 0."
	
	PlcFirstEntryIndex to: self plcSize - 1 by: PointersPerPlcEntry do: [ :index |
		class == (objectMemory fetchPointer: index + PlcLkupClassIndex ofObject: plc)
			ifTrue: [ ^ index ] ].
	^ 0! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/17/2014 23:54'!
instantiateClass: class ofSize: size
	
	| spaceOkay |
	spaceOkay := self sufficientSpaceToInstantiate: class indexableSize: size.
	self success: spaceOkay.
	^ objectMemory instantiateClass: class indexableSize: size! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/17/2014 23:54'!
instantiatePLC
	"Return an uninitialized instance of PLCStruct.
	This assumes that 'objectMemory hasPLCStruct' returns true!! Otherwise probably segfault."
	
	^ self instantiateClass: ObjectMemory classPLCStruct ofSize: self plcSize! !

!PLCInterpreter methodsFor: 'as yet unclassified' stamp: 'ag 1/20/2014 23:59'!
internalAboutToReturn: resultObj through: aContext
	<inline: true>
	syntheticMessageSend := true.
	^ super internalAboutToReturn: resultObj through: aContext! !

!PLCInterpreter methodsFor: 'as yet unclassified' stamp: 'ag 1/20/2014 23:59'!
internalCannotReturn: resultObj
	<inline: true>
	syntheticMessageSend := true.
	^ super internalCannotReturn: resultObj! !

!PLCInterpreter methodsFor: 'message sending' stamp: 'ag 1/20/2014 19:35'!
internalFindNewMethod
	"If current method is not flagged, fall back to regular method lookup cache.
	Otherwise load the PLC data at current callsite and handle the PLC.
	Afterwards, jump over the 2 bytes after the current send-bytecode."
	
	<inline: true>
	| plcIndex plc |
	self handlingPLCMethod ifFalse: [ ^ self doMethodLookup ].
	plcIndex := self plcIndexAtCallsite: localIP.
	plc := self literal: plcIndex.
	(self checkCorrectClassOf: plc at: plcIndex) ifFalse: [ ^ self doMethodLookup. ].
	self internalHandlePLC: plc at: plcIndex.
	self internalJumpOverCallsite.! !

!PLCInterpreter methodsFor: 'message sending' stamp: 'ag 1/17/2014 22:01'!
internalHandlePLC: plc at: plcIndex
	"If a PLC is already present, do a lookup.
	If no PLC is present, or the lookup fails, do a regular lookup.
	Then create a new PLC if required and add the new entry."
	
	| initialized |
	self debugPLC: plc atIndex: plcIndex.
	initialized := self isInitializedPLC: plc.
	(initialized and: [ self lookupClass: lkupClass inPLC: plc ])
		ifFalse: [
			self doMethodLookup.
			initialized
				ifTrue: [ self addToPLC: plc ]
				ifFalse: [ self createNewPLCAt: plcIndex ] ].! !

!PLCInterpreter methodsFor: 'message sending' stamp: 'ag 1/16/2014 15:26'!
internalJumpOverCallsite
	"Skip the two bytes that are located right after a send-bytecode."
	
	<inline: true>
	localIP := localIP + 2.! !

!PLCInterpreter methodsFor: 'compiled methods' stamp: 'ag 1/15/2014 11:01'!
isBytesObject: oop
	
	^ (objectMemory formatOf: oop) >= 8! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/20/2014 20:46'!
isInDebuggedMethod
	
	DebugPLC ifFalse: [ ^ false ].
	^ (self checkString: messageSelector equals: 'changeRecordForOverriddenMethod:') "invoked method"
	and: [ self checkString: (self selectorOfMethod: method) equals: 'isOverrideOfYourMethod:' ] "containing method"! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/16/2014 15:38'!
isInitializedPLC: plc
	"We check if the plc-pointer is nil or already initialized to an instance of PLCStruct.
	Literals of a CompiledMethod are initialized to nil.
	Since we keep the plc-reference in a literal slot of a Method, the GC will not collect it."
	
	^ plc ~~ objectMemory nilObj! !

!PLCInterpreter methodsFor: 'as yet unclassified' stamp: 'ag 1/20/2014 23:59'!
jumplfFalseBy: offset
	<inline: true>
	syntheticMessageSend := true.
	^ super jumplfFalseBy: offset! !

!PLCInterpreter methodsFor: 'as yet unclassified' stamp: 'ag 1/20/2014 23:59'!
jumplfTrueBy: offset
	<inline: true>
	syntheticMessageSend := true.
	^ super jumplfTrueBy: offset! !

!PLCInterpreter methodsFor: 'compiled methods' stamp: 'ag 1/16/2014 15:55'!
literal: offset ofMethod: methodPointer store: value
	
	objectMemory storePointer: offset + LiteralStart ofObject: methodPointer withValue: value.! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/17/2014 20:36'!
lookupClass: class inPLC: plc
	"Linear search over the contents of the PLCStruct until we find the required class.
	Return false if the class is not find anywhere.
	C compiler should unroll constant loop."
	
	<inline: true>
	| index |
	index := self indexOfClass: class inPLC: plc.
	index = 0 ifTrue: [ ^ false ].
	self restoreFromPlc: plc index: index.
	^ true! !

!PLCInterpreter methodsFor: 'message sending' stamp: 'ag 1/17/2014 20:41'!
plcIndexAtCallsite: localInstructionPointer
	"After a send-bytecode, we insert an ignored jump+1 instruction,
	and after that we have the literal-index for the plc of the current callsite."
	
	<inline: true>
	^ objectMemory byteAtPointer: localInstructionPointer + 2! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/19/2014 15:00'!
plcSize
	"We add one pointer to store the selector associated with the PLCStruct."
	
	^ PlcMetaInfoEntries + (PlcEntries * PointersPerPlcEntry)! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/17/2014 18:47'!
printBits: b
	"b has 4 bytes.
	Print bits, starting with most significant."
	
	0 to: 31 do: [ :i |
		((b bitAnd: (1 << (31 - i))) == 0)
			ifTrue: [ self print: '0' ]
			ifFalse: [ self print: '1' ].
		((i+1) \\ 8) == 0 ifTrue: [ self print: ' ' ].
	]! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/18/2014 00:09'!
printCacheEntry: index of: plc
	
	self print: 'Cache-Entry index '.
	self printNum: index.
	self print: ' - Class: '.
	self printClass: (objectMemory fetchPointer: index + PlcLkupClassIndex ofObject: plc).
	self print: ' NewMethod: '.
	self printPointer: (objectMemory fetchPointer: index + PlcNewMethodIndex ofObject: plc).
	self print: ' PrimitiveIndex: '.
	self printPointer: (objectMemory fetchPointer: index + PlcPrimitiveIndex ofObject: plc).
	self print: ' NewNativeMethod: '.
	self printPointer: (objectMemory fetchPointer: index + PlcNewNativeMethodIndex ofObject: plc).! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/18/2014 00:09'!
printClass: class
	
	self printPointer: class.
	self print: ' ('.
	self printStringOf: (self classNameOf: class).
	self print: ')'.! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/19/2014 17:00'!
printPLC: plc
	
	self printPointer: plc.
	self print: ' <'.
	(self isInitializedPLC: plc)
		ifTrue: [
			self printStringOf: (objectMemory fetchPointer: PlcMessageSelectorIndex ofObject: plc).
			self print: '> '.
			PlcFirstEntryIndex to: self plcSize - 1 by: PointersPerPlcEntry do: [ :i | | class |
				self print: '['.
				class := objectMemory fetchPointer: i ofObject: plc.
				class = objectMemory nilObj
					ifTrue: [ self print: '<nil>' ]
					ifFalse: [ self printClass: class ].
				self print: '] ' ] ]
		ifFalse: [
			self printStringOf: messageSelector.
			self print: '> uninitialized' ].! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/18/2014 00:22'!
printPLC: plc atIndex: index
	
	self print: 'PLC index: '.
	self printNum: index.
	self print: ', '.
	self printPLC: plc.! !

!PLCInterpreter methodsFor: 'debugging' stamp: 'ag 1/17/2014 18:52'!
printPointer: p
	
	self cCode: 'printf("%p", (void*) p)'.! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/20/2014 18:46'!
restoreFromPlc: plc index: index
	"Index is already a valid index into the PLCStruct.
	Using localPrimIndex is a small optimization to avoid some indirect memory accesses."
	
	newMethod := objectMemory fetchPointer: index + PlcNewMethodIndex ofObject: plc.
	newNativeMethod := objectMemory fetchPointer: index + PlcNewNativeMethodIndex ofObject: plc.
	primitiveIndex := objectMemory integerValueOf: (objectMemory fetchPointer: index + PlcPrimitiveIndex ofObject: plc).
	self setPrimitiveFunctionPointer: primitiveIndex.
	self debugRestoredFrom: plc index: index.! !

!PLCInterpreter methodsFor: 'compiled methods' stamp: 'ag 1/15/2014 11:03'!
selectorOfMethod: mt
	"The second last literal of a method usually either contains the selector as a symbol, or
	an instance of AdditionalMethodState that has the selector as instance variable."
	
	| literal |
	literal := self literal: (self literalCountOf: mt) - 2 ofMethod: mt.
	(self isBytesObject: literal) ifTrue: [ ^ literal ].
	^ self fetchPointer: 1 ofObject: literal! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/20/2014 18:47'!
setPrimitiveFunctionPointer: index
	
	<inline: false>
	index = 0 ifFalse: [
		primitiveFunctionPointer := self functionPointerFor: index inClass: lkupClass ].! !

!PLCInterpreter methodsFor: 'polymorphic lookup cache' stamp: 'ag 1/20/2014 18:47'!
storeIntoPlc: plc index: index
	"Put the current state into the plc at the given index.
	Optimization - do the young-check once and store pointers unchecked. See #storePointer:ofObject:withValue:"
	
	(objectMemory isOldNonIntegerOop: plc) ifTrue: [
		self possibleRootStoreInto: plc value: lkupClass.
		self possibleRootStoreInto: plc value: newMethod.
		self possibleRootStoreInto: plc value: newNativeMethod.
	].
	objectMemory storePointerUnchecked: index + PlcLkupClassIndex ofObject: plc withValue: lkupClass.
	objectMemory storePointerUnchecked: index + PlcNewMethodIndex ofObject: plc withValue: newMethod.
	objectMemory storePointerUnchecked: index + PlcNewNativeMethodIndex ofObject: plc withValue: newNativeMethod.
	objectMemory storePointerUnchecked: index + PlcPrimitiveIndex ofObject: plc withValue: (objectMemory integerObjectOf: primitiveIndex).
	self debugStoredInto: plc index: index.! !

!VeryLongJumpInterpreter class methodsFor: 'initialization' stamp: 'ag 1/20/2014 19:39'!
initializeBytecodeTable
	"Overwrite original to add a new bytecode - veryLongJump"

	"Interpreter initializeBytecodeTable"
	"Note: This table will be used to generate a C switch statement."

	BytecodeTable := Array new: 256.
	self table: BytecodeTable from:
	#(
		(  0  15 pushReceiverVariableBytecode)
		( 16  31 pushTemporaryVariableBytecode)
		( 32  63 pushLiteralConstantBytecode)
		( 64  95 pushLiteralVariableBytecode)
		( 96 103 storeAndPopReceiverVariableBytecode)
		(104 111 storeAndPopTemporaryVariableBytecode)
		(112 pushReceiverBytecode)
		(113 pushConstantTrueBytecode)
		(114 pushConstantFalseBytecode)
		(115 pushConstantNilBytecode)
		(116 pushConstantMinusOneBytecode)
		(117 pushConstantZeroBytecode)
		(118 pushConstantOneBytecode)
		(119 pushConstantTwoBytecode)
		(120 returnReceiver)
		(121 returnTrue)
		(122 returnFalse)
		(123 returnNil)
		(124 returnTopFromMethod)
		(125 returnTopFromBlock)
		
		(126 veryLongJump)
		(127 unknownBytecode)

		(128 extendedPushBytecode)
		(129 extendedStoreBytecode)
		(130 extendedStoreAndPopBytecode)
		(131 singleExtendedSendBytecode)
		(132 doubleExtendedDoAnythingBytecode)
		(133 singleExtendedSuperBytecode)
		(134 secondExtendedSendBytecode)
		(135 popStackBytecode)
		(136 duplicateTopBytecode)

		(137 pushActiveContextBytecode)
		(138 pushNewArrayBytecode)
		(139 unknownBytecode)
		(140 pushRemoteTempLongBytecode)
		(141 storeRemoteTempLongBytecode)
		(142 storeAndPopRemoteTempLongBytecode)
		(143 pushClosureCopyCopiedValuesBytecode)

		(144 151 shortUnconditionalJump)
		(152 159 shortConditionalJump)
		(160 167 longUnconditionalJump)
		(168 171 longJumpIfTrue)
		(172 175 longJumpIfFalse)

		"176-191 were sendArithmeticSelectorBytecode"
		(176 bytecodePrimAdd)
		(177 bytecodePrimSubtract)
		(178 bytecodePrimLessThan)
		(179 bytecodePrimGreaterThan)
		(180 bytecodePrimLessOrEqual)
		(181 bytecodePrimGreaterOrEqual)
		(182 bytecodePrimEqual)
		(183 bytecodePrimNotEqual)
		(184 bytecodePrimMultiply)
		(185 bytecodePrimDivide)
		(186 bytecodePrimMod)
		(187 bytecodePrimMakePoint)
		(188 bytecodePrimBitShift)
		(189 bytecodePrimDiv)
		(190 bytecodePrimBitAnd)
		(191 bytecodePrimBitOr)	

		"192-207 were sendCommonSelectorBytecode"
		(192 bytecodePrimAt)
		(193 bytecodePrimAtPut)
		(194 bytecodePrimSize)
		(195 bytecodePrimNext)
		(196 bytecodePrimNextPut)
		(197 bytecodePrimAtEnd)
		(198 bytecodePrimEquivalent)
		(199 bytecodePrimClass)
		(200 bytecodePrimBlockCopy)
		(201 bytecodePrimValue)
		(202 bytecodePrimValueWithArg)
		(203 bytecodePrimDo)
		(204 bytecodePrimNew)
		(205 bytecodePrimNewWithArg)
		(206 bytecodePrimPointX)
		(207 bytecodePrimPointY)

		(208 255 sendLiteralSelectorBytecode)
	).! !

!VeryLongJumpInterpreter methodsFor: 'bytecodes' stamp: 'ag 1/20/2014 19:39'!
veryLongJump
	
	| offset |
	offset := (self fetchByte - 128) * 256 + self fetchByte.
	localIP := localIP + offset.
	offset < 0 ifTrue: [
		"backward jump means we're in a loop; check for possible interrupts"
		self internalQuickCheckForInterrupts.
	].
	self fetchNextBytecode! !

!CompiledMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 12:05'!
canHandlePlcLiterals
	"If this method does not contain PLCs yet, it must have enough literals
	available to hold one extra object per callsite."
	
	^ self flag or: [ 255 > (self numLiterals + (PLCConfiguration messagesInMethod: self) size) ]! !

!CompiledMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 20:21'!
flushCache
	
	self flushPLCCache.
	self flushOriginalMethodCache.! !

!CompiledMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/17/2014 15:32'!
flushOriginalMethodCache
	"Tell the interpreter to remove all references to this method from its method lookup cache, if it has one.  This primitive must be called whenever a method is defined or removed.
	NOTE:  Only one of two selective flush methods needs to be used.
	Squeak 2.2 and earlier uses 119 (See Symbol flushCache).
	Squeak 2.3 and later uses 116 (See CompiledMethod flushCache)."

	<primitive: 116>
! !

!CompiledMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 13:51'!
flushPLCCache
	
	PLCStruct allInstancesDo: [ :struct |
		struct flushMethod: self ].! !

!CompiledMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 14:30'!
hasPLCLiteral
	
	^ self literals anySatisfy: [ :lit | lit class == PLCStruct ]! !

!CompiledMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/19/2014 15:33'!
recompile
	
	^ self methodClass recompile: self selector! !

!CompiledMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/19/2014 17:12'!
recompileWithPLC
	
	PLCConfiguration enablePlcCompilation.
	^ self recompile! !

!CompiledMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/19/2014 17:11'!
recompileWithoutPLC
	
	PLCConfiguration disablePlcCompilation.
	^ self recompile! !

!CompiledMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/13/2014 16:07'!
setFlag
	"Set the user-level flag bit"
	
	self objectAt: 1 put: (self header bitOr: (1 << 29))! !

!TMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/15/2014 10:22'!
allLocals
	"The merge of locals and declarations (don't ask)"

	^(declarations keys asSet reject: [:k| (declarations at: k) == #implicit])
		addAll: locals; yourself! !

!TMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 13:49'!
comment
	^comment! !

!TMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 13:50'!
elideAnyFinalReturn
	"For super expansions we need to eliminate any final return to prevent premature exit.
	 Anything meaningful in the returned expression must be retained."

	| stmtList expr |
	stmtList := parseTree statements asOrderedCollection.
	stmtList last isReturn ifTrue:
		[expr := stmtList last expression.
		 (expr isVariable and: [expr name = 'self'])
			ifTrue: [stmtList := stmtList allButLast]
			ifFalse: [stmtList at: stmtList size put: expr].
		parseTree setStatements: stmtList]! !

!TMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 13:50'!
extraVariableNumber
	^extraVariableNumber! !

!TMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 13:47'!
hasProperties
	^properties notNil and: [properties notEmpty]! !

!TMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 13:45'!
mergePropertiesOfSuperMethod: superTMethod
	superTMethod hasProperties ifFalse:
		[^self].
	self hasProperties ifFalse:
		[properties := superTMethod properties.
		 ^self].
	superTMethod properties pragmas do:
		[:aPragma|
		(self shouldIncorporatePragmaFromSuperMethod: aPragma) ifTrue:
			[properties := properties copyWith: aPragma]]! !

!TMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 13:47'!
properties
	^ properties! !

!TMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 13:46'!
shouldIncorporatePragmaFromSuperMethod: aPragma
	(properties includesKey: aPragma keyword) ifFalse:
		[^true].
	((aPragma keyword beginsWith: #var:)
	  and: [properties pragmas noneSatisfy:
			[:p|
			(p keyword beginsWith: #var:)
			and: [(p argumentAt: 1) = (aPragma argumentAt: 1)]]]) ifTrue:
		[^true].
	^false! !

!TMethod methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 13:44'!
superExpansionNodeFor: aSelector args: argumentNodes
	"Answer the expansion of a super send.  Merge the super expansion's
	 locals, properties and comment into this method's properties."
	
	(definingClass superclass lookupSelector: aSelector)
		ifNil: [self error: 'superclass does not define super method']
		ifNotNil:
			[:superMethod| | superTMethod commonVars varMap |
			superTMethod := superMethod methodNode asTranslationMethodOfClass: self class.
			((argumentNodes allSatisfy: [:parseNode| parseNode isVariableNode])
			and: [(argumentNodes asOrderedCollection collect: [:parseNode| parseNode key]) = superTMethod args]) ifFalse:
				[self error: definingClass name, '>>',selector, ' args ~= ',
							superTMethod definingClass name, '>>', aSelector,
							(String with: $. with: Character cr),
							'For super expansions to be translated correctly each argument must be a variable with the same name as the corresponding argument in the super method.'].
			self mergePropertiesOfSuperMethod: superTMethod.
			(commonVars := superTMethod locals intersection: self locals) notEmpty ifTrue:
				[varMap := Dictionary new.
				 commonVars do:
					[:k| varMap at: k put: (superTMethod unusedNamePrefixedBy: k avoiding: self allLocals)].
				 superTMethod renameVariablesUsing: varMap].
			self assert: (superTMethod locals allSatisfy: [:var| (self locals includes: var) not]).
			locals addAll: superTMethod locals.
			superTMethod declarations keysAndValuesDo:
				[:var :decl|
				self declarationAt: var put: decl].
			superTMethod comment ifNotNil:
				[:superComment|
				comment := comment
								ifNil: [superComment]
								ifNotNil: [superComment, comment]].
			superTMethod extraVariableNumber ifNotNil:
				[:scvn|
				extraVariableNumber := extraVariableNumber ifNil: [scvn] ifNotNil: [:cvn| cvn + scvn]].
			superTMethod elideAnyFinalReturn.
			^superTMethod parseTree]! !

!SelectorNode methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 10:31'!
copyWithoutPlcLiteral
	
	| copy |
	copy := self copy.
	copy forgetPlcLiteral.
	^ copy! !

!SelectorNode methodsFor: '*VMs-Seminar' stamp: 'ag 1/16/2014 14:59'!
emitCode: stack args: nArgs encoder: encoder super: supered
	| result |
	stack pop: nArgs.
	result := supered
		ifTrue:
			[encoder genSendSuper: index numArgs: nArgs]
		ifFalse:
			[encoder
				genSend: (code < Send ifTrue: [code negated] ifFalse: [index])
				numArgs: nArgs].
	PLCConfiguration plcCompilationEnabled ifTrue: [ encoder genPLCStub: plcLiteral ].
	^ result! !

!SelectorNode methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 10:31'!
forgetPlcLiteral
	
	plcLiteral := nil.! !

!SelectorNode methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 10:14'!
sizeCode: encoder args: nArgs super: supered
	| size |
	self reserve: encoder.
	size := supered
		ifTrue:
			[code < Send "i.e. its a special selector" ifTrue:
				[code := self code: (index := encoder sharableLitIndex: key) type: 5].
			 encoder sizeSendSuper: index numArgs: nArgs]
		ifFalse:
			[self flag: #yuck. "special selector sends cause this problem"
			 encoder
				sizeSend: (code < Send ifTrue: [code negated] ifFalse: [index])
				numArgs: nArgs].
	PLCConfiguration plcCompilationEnabled
		ifTrue: [
			"At a PLC callsite, we store 2 bytes: one to jump over the second byte
			in case a non-modified VM is used, and a second one storing the literal-index for the plc-pointer.
			Allocate the PLCStruct now, at compile-time. Less work for the VM."
			size := size + 2.
			plcLiteral ifNil: [
				plcLiteral := encoder litIndex: (PLCStruct forSelector: key) ] ].
	^ size! !

!InstructionStream methodsFor: '*VMs-Seminar' stamp: 'ag 1/16/2014 15:08'!
aboutToSend
	"Skip bytes reserved for plc literal index."
	
	self method flag ifTrue: [ pc := pc + 2 ].! !

!InstructionStream methodsFor: '*VMs-Seminar' stamp: 'ag 1/16/2014 15:08'!
interpretExtension: offset in: method for: client
	| type offset2 byte2 byte3 byte4 |
	offset <= 6 ifTrue: 
		["Extended op codes 128-134"
		byte2 := method at: pc. pc := pc + 1.
		offset <= 2 ifTrue:
			["128-130:  extended pushes and pops"
			type := byte2 // 64.
			offset2 := byte2 \\ 64.
			offset = 0 ifTrue: 
				[type = 0 ifTrue: [^client pushReceiverVariable: offset2].
				type = 1 ifTrue: [^client pushTemporaryVariable: offset2].
				type = 2  ifTrue: [^client pushConstant: (method literalAt: offset2 + 1)].
				type = 3 ifTrue: [^client pushLiteralVariable: (method literalAt: offset2 + 1)]].
			offset = 1 ifTrue: 
				[type = 0 ifTrue: [^client storeIntoReceiverVariable: offset2].
				type = 1 ifTrue: [^client storeIntoTemporaryVariable: offset2].
				type = 2 ifTrue: [self error: 'illegalStore'].
				type = 3 ifTrue: [^client storeIntoLiteralVariable: (method literalAt: offset2 + 1)]].
			offset = 2 ifTrue: 
				[type = 0 ifTrue: [^client popIntoReceiverVariable: offset2].
				type = 1 ifTrue: [^client popIntoTemporaryVariable: offset2].
				type = 2 ifTrue: [self error: 'illegalStore'].
				type = 3  ifTrue: [^client popIntoLiteralVariable: (method literalAt: offset2 + 1)]]].
		"131-134: extended sends"
		offset = 3 ifTrue:  "Single extended send"
			[
			self aboutToSend.
			^client send: (method literalAt: byte2 \\ 32 + 1)
					super: false numArgs: byte2 // 32].
		offset = 4 ifTrue:    "Double extended do-anything"
			[byte3 := method at: pc. pc := pc + 1.
			type := byte2 // 32.
			type = 0 ifTrue: [
				self aboutToSend.
				^client send: (method literalAt: byte3 + 1)
									super: false numArgs: byte2 \\ 32].
			type = 1 ifTrue: [
				self aboutToSend.
				^client send: (method literalAt: byte3 + 1)
									super: true numArgs: byte2 \\ 32].
			type = 2 ifTrue: [^client pushReceiverVariable: byte3].
			type = 3 ifTrue: [^client pushConstant: (method literalAt: byte3 + 1)].
			type = 4 ifTrue: [^client pushLiteralVariable: (method literalAt: byte3 + 1)].
			type = 5 ifTrue: [^client storeIntoReceiverVariable: byte3].
			type = 6 ifTrue: [^client popIntoReceiverVariable: byte3].
			type = 7 ifTrue: [^client storeIntoLiteralVariable: (method literalAt: byte3 + 1)]].
		offset = 5 ifTrue:  "Single extended send to super"
			[
			self aboutToSend.
			^client send: (method literalAt: byte2 \\ 32 + 1)
					super: true numArgs: byte2 // 32].
		offset = 6 ifTrue:   "Second extended send"
			[
			self aboutToSend.
			^client send: (method literalAt: byte2 \\ 64 + 1)
					super: false numArgs: byte2 // 64]].
	offset = 7 ifTrue: [^client doPop].
	offset = 8 ifTrue: [^client doDup].
	offset = 9 ifTrue: [^client pushActiveContext].
	byte2 := method at: pc. pc := pc + 1.
	offset = 10 ifTrue:
		[^byte2 < 128
			ifTrue: [client pushNewArrayOfSize: byte2]
			ifFalse: [client pushConsArrayWithElements: byte2 - 128]].
	offset = 11 ifTrue: [^self error: 'unusedBytecode'].
	byte3 := method at: pc.  pc := pc + 1.
	offset = 12 ifTrue: [^client pushRemoteTemp: byte2 inVectorAt: byte3].
	offset = 13 ifTrue: [^client storeIntoRemoteTemp: byte2 inVectorAt: byte3].
	offset = 14 ifTrue: [^client popIntoRemoteTemp: byte2 inVectorAt: byte3].
	"offset = 15"
	byte4 := method at: pc.  pc := pc + 1.
	^client
		pushClosureCopyNumCopiedValues: (byte2 bitShift: -4)
		numArgs: (byte2 bitAnd: 16rF)
		blockSize: (byte3 * 256) + byte4! !

!InstructionStream methodsFor: '*VMs-Seminar' stamp: 'ag 1/16/2014 15:09'!
interpretNextInstructionFor: client 
	"Send to the argument, client, a message that specifies the type of the 
	next instruction."

	| byte type offset method |
	method := self method.  
	byte := method at: pc.
	type := byte // 16.  
	offset := byte \\ 16.  
	pc := pc+1.
	"We do an inline binary search on each of the possible 16 values of type:
	The old, cleaner but slowe code is retained as a comment below"
	type < 8
	ifTrue: [type < 4
				ifTrue: [type < 2
						ifTrue: [type < 1
								ifTrue: ["type = 0"
									^ client pushReceiverVariable: offset]
								ifFalse: ["type = 1"
									^ client pushTemporaryVariable: offset]]
						ifFalse: [type < 3
								ifTrue: ["type = 2"
									^ client
										pushConstant: (method literalAt: offset + 1)]
								ifFalse: ["type = 3"
									^ client
										pushConstant: (method literalAt: offset + 17)]]]
				ifFalse: [type < 6
						ifTrue: [type < 5
								ifTrue: ["type = 4"
									^ client
										pushLiteralVariable: (method literalAt: offset + 1)]
								ifFalse: ["type = 5"
									^ client
										pushLiteralVariable: (method literalAt: offset + 17)]]
						ifFalse: [type < 7
								ifTrue: ["type = 6"
									offset < 8
										ifTrue: [^ client popIntoReceiverVariable: offset]
										ifFalse: [^ client popIntoTemporaryVariable: offset - 8]]
								ifFalse: ["type = 7"
									offset = 0
										ifTrue: [^ client pushReceiver].
									offset < 8
										ifTrue: [^ client
												pushConstant: (SpecialConstants at: offset)].
									offset = 8
										ifTrue: [^ client methodReturnReceiver].
									offset < 12
										ifTrue: [^ client
												methodReturnConstant: (SpecialConstants at: offset - 8)].
									offset = 12
										ifTrue: [^ client methodReturnTop].
									offset = 13
										ifTrue: [^ client blockReturnTop].
									offset = 14
										ifTrue: [
											"actually an unused bytecode, but misused as 'very long jump'.
											Added for VMs-Seminar."
											| byte1 byte2 |
											byte1 := method at: pc.  pc:= pc+1.
											byte2 := method at: pc.  pc:= pc+1.
											^ client jump: (byte1 - 128) * 256 + byte2 ].
									offset > 13
										ifTrue: [^ self error: 'unusedBytecode']]]]]
		ifFalse: [type < 12
				ifTrue: [type < 10
						ifTrue: [type < 9
								ifTrue: ["type = 8"
									^ self
										interpretExtension: offset
										in: method
										for: client]
								ifFalse: ["type = 9 (short jumps)"
									offset < 8
										ifTrue: [^ client jump: offset + 1].
									^ client jump: offset - 8 + 1 if: false]]
						ifFalse: [type < 11
								ifTrue: ["type = 10 (long jumps)"
									byte := method at: pc.
									pc := pc + 1.
									offset < 8
										ifTrue: [^ client jump: offset - 4 * 256 + byte].
									^ client jump: (offset bitAnd: 3)
											* 256 + byte if: offset < 12]
								ifFalse: ["type = 11"
									self aboutToSend.
									^ client
										send: (Smalltalk specialSelectorAt: offset + 1)
										super: false
										numArgs: (Smalltalk specialNargsAt: offset + 1)]]]
				ifFalse: [type = 12
						ifTrue: [
							self aboutToSend.
							^ client
								send: (Smalltalk specialSelectorAt: offset + 17)
								super: false
								numArgs: (Smalltalk specialNargsAt: offset + 17)]
						ifFalse: ["type = 13, 14 or 15"
							self aboutToSend.
							^ client
								send: (method literalAt: offset + 1)
								super: false
								numArgs: type - 13]]].


"    old code 
	type=0 ifTrue: [^client pushReceiverVariable: offset].
	type=1 ifTrue: [^client pushTemporaryVariable: offset].
	type=2 ifTrue: [^client pushConstant: (method literalAt: offset+1)].
	type=3 ifTrue: [^client pushConstant: (method literalAt: offset+17)].
	type=4 ifTrue: [^client pushLiteralVariable: (method literalAt: offset+1)].
	type=5 ifTrue: [^client pushLiteralVariable: (method literalAt: offset+17)].
	type=6 
		ifTrue: [offset<8
					ifTrue: [^client popIntoReceiverVariable: offset]
					ifFalse: [^client popIntoTemporaryVariable: offset-8]].
	type=7
		ifTrue: [offset=0 ifTrue: [^client pushReceiver].
				offset<8 ifTrue: [^client pushConstant: (SpecialConstants at: offset)].
				offset=8 ifTrue: [^client methodReturnReceiver].
				offset<12 ifTrue: [^client methodReturnConstant: 
												(SpecialConstants at: offset-8)].
				offset=12 ifTrue: [^client methodReturnTop].
				offset=13 ifTrue: [^client blockReturnTop].
				offset>13 ifTrue: [^self error: 'unusedBytecode']].
	type=8 ifTrue: [^self interpretExtension: offset in: method for: client].
	type=9
		ifTrue:  short jumps
			[offset<8 ifTrue: [^client jump: offset+1].
			^client jump: offset-8+1 if: false].
	type=10 
		ifTrue:  long jumps
			[byte:= method at: pc.  pc:= pc+1.
			offset<8 ifTrue: [^client jump: offset-4*256 + byte].
			^client jump: (offset bitAnd: 3)*256 + byte if: offset<12].
	type=11 
		ifTrue: 
			[^client 
				send: (Smalltalk specialSelectorAt: offset+1) 
				super: false
				numArgs: (Smalltalk specialNargsAt: offset+1)].
	type=12 
		ifTrue: 
			[^client 
				send: (Smalltalk specialSelectorAt: offset+17) 
				super: false
				numArgs: (Smalltalk specialNargsAt: offset+17)].
	type>12
		ifTrue: 
			[^client send: (method literalAt: offset+1) 
					super: false
					numArgs: type-13]"! !

!InstructionStream methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 12:14'!
nextPc: currentByte
	"Answer the pc of the next bytecode following the current one, given the current bytecode.."

	| type |
	currentByte = 126 ifTrue: [ ^ pc + 3 ].
	type := currentByte // 16.
	^type = 8 "extensions"
				ifTrue: [pc + (#(2 2 2 2 3 2 2 1 1 1 2 1 3 3 3 4) at: currentByte \\ 16 + 1)]
				ifFalse: [type = 10 "long jumps"
							ifTrue: [pc + 2]
							ifFalse: [pc + 1]]! !

!CCodeGenerator methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 15:07'!
addMethod: aTMethod
	"Add the given method to the code base."

	(methods includesKey:  aTMethod selector) ifTrue: [
		Transcript cr; show: 'Adding again: ', aTMethod selector.
		^ self
		"self error: 'Method name conflict: ', aTMethod selector."
	].
	methods at: aTMethod selector put: aTMethod.! !

!CCodeGenerator methodsFor: '*VMs-Seminar' stamp: 'ag 1/14/2014 13:51'!
checkClassForNameConflicts: aClass
	"Verify that the given class does not have constant, variable, or method names that conflict with
	 those of previously added classes. Raise an error if a conflict is found, otherwise just return."

	"check for constant name collisions in class pools"
	aClass classPool associationsDo:
		[:assoc |
		(constants includesKey: assoc key asString) ifTrue:
			[self error: 'Constant ', assoc key, ' was defined in a previously added class']].

	"and in shared pools"
	(aClass sharedPools reject: [:pool| pools includes: pool]) do:
		[:pool |
		pool bindingsDo:
			[:assoc |
			(constants includesKey: assoc key asString) ifTrue:
				[self error: 'Constant ', assoc key, ' was defined in a previously added class']]].

	"check for instance variable name collisions"
	(aClass inheritsFrom: VMStructType) ifFalse:
		[aClass instVarNames do:
			[:varName |
			(variables includes: varName) ifTrue:
				[self error: 'Instance variable ', varName, ' was defined in a previously added class']]].

	"check for method name collisions"
	aClass selectors do:
		[:sel |
		((methods includesKey: sel) and:
			[ | meth |
			meth := aClass compiledMethodAt: sel.
			meth isAbstract not and: [(meth pragmaAt: #doNotGenerate) isNil]]) ifTrue:
				["self error: 'Method ', sel, ' was defined in a previously added class.'"]]! !

!EncoderForV3 methodsFor: '*VMs-Seminar' stamp: 'ag 1/7/2014 16:32'!
genBranchPopFalse: distance
	"See BlueBook page 596"
	distance < 0 ifTrue:
		[^self outOfRangeError: 'distance' index: distance range: 0 to: 1023].
	(distance > 0 and: [distance < 9]) ifTrue:
		["152-159 	10011iii 	Pop and Jump 0n False iii +1 (i.e., 1 through 8)"
		 stream nextPut: 152 + distance - 1.
		 ^self].
	distance < 1024 ifTrue:
		["172-175 	101011ii jjjjjjjj 	Pop and Jump On False ii *256+jjjjjjjj"
		 stream
			nextPut: 172 + (distance bitShift: -8);
			nextPut: distance + 1024 \\ 256.
		 ^self].
	PLCConfiguration veryLongJumpCompilationEnabled ifTrue: [ ^ self genVeryLongJump: distance precededBy: 135 ].
	^self outOfRangeError: 'distance' index: distance range: 0 to: 1023! !

!EncoderForV3 methodsFor: '*VMs-Seminar' stamp: 'ag 1/7/2014 16:32'!
genBranchPopTrue: distance
	"See BlueBook page 596"
	distance < 0 ifTrue:
		[^self outOfRangeError: 'distance' index: distance range: 0 to: 1023].
	distance < 1024 ifTrue:
		["168-171 	101010ii jjjjjjjj 	Pop and Jump On True ii *256+jjjjjjjj"
		 stream
			nextPut: 168 + (distance bitShift: -8);
			nextPut: distance + 1024 \\ 256.
		 ^self].
	PLCConfiguration veryLongJumpCompilationEnabled ifTrue: [ ^ self genVeryLongJump: distance precededBy: 135 ].
	^self outOfRangeError: 'distance' index: distance range: 0 to: 1023! !

!EncoderForV3 methodsFor: '*VMs-Seminar' stamp: 'ag 1/7/2014 16:32'!
genJumpLong: distance
	"See BlueBook page 596"
	
	"Forcing the very-long-jump, if enabled."
	PLCConfiguration veryLongJumpCompilationEnabled ifTrue: [ ^ self genVeryLongJump: distance ].
	
	(distance >= -1024 and: [distance < 1024]) ifTrue:
		["160-167 	10100iii jjjjjjjj 	Jump(iii - 4) *256+jjjjjjjj"
		 stream
			nextPut: 160 + (distance + 1024 bitShift: -8);
			nextPut: distance + 1024 \\ 256.
		 ^self].
	^self outOfRangeError: 'distance' index: distance range: -1023 to: 1024! !

!EncoderForV3 methodsFor: '*VMs-Seminar' stamp: 'ag 1/19/2014 16:11'!
genPLCStub: plcLiteral
	"First byte: simple jump bytecode to jump over the second byte.
	Second byte: the literal-index that will store a PLCStruct for this callsite."
	
	stream
		nextPut: 144; "jump +1"
		nextPut: plcLiteral.! !

!EncoderForV3 methodsFor: '*VMs-Seminar' stamp: 'ag 1/7/2014 15:20'!
genVeryLongJump: distance
	
	self genVeryLongJump: distance precededBy: 0.! !

!EncoderForV3 methodsFor: '*VMs-Seminar' stamp: 'ag 1/7/2014 16:43'!
genVeryLongJump: distance precededBy: extraBytecode
	"This was added for the VMs-Seminar."
	"We are using the unused bytecode 126 + 2 extra bytes encoding the jump destination."
	
	PLCConfiguration veryLongJumpCompilationEnabled ifFalse: [ ^ self ].
	(distance >= -32768 and: [distance < 32768]) ifFalse:
		[ ^ self outOfRangeError: 'distance' index: distance range: -32768 to: 32767 ].
	extraBytecode = 0 ifFalse: [
		stream nextPut: extraBytecode ].
	stream
		nextPut: 126;
		nextPut: (distance bitShift: -8) + 128;
		nextPut: distance \\ 256.! !

!Behavior methodsFor: '*VMs-Seminar' stamp: 'ag 1/17/2014 15:03'!
recompileAll
	
	self selectors do: [ :sel | self recompile: sel ].! !

!Behavior methodsFor: '*VMs-Seminar' stamp: 'ag 1/19/2014 17:12'!
recompileWithPLCs
	
	PLCConfiguration enablePlcCompilation.
	self recompileAll.! !

!Behavior methodsFor: '*VMs-Seminar' stamp: 'ag 1/19/2014 17:11'!
recompileWithoutPLCs
	
	PLCConfiguration disablePlcCompilation.
	self recompileAll.! !

Object subclass: #PLCConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMs-Seminar'!

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/19/2014 17:10'!
automaticallySetFlag
	"If this returns true, every method compiled with PLC-support will also be flagged,
	so that the VM will actually use the PLCs. Should only be enabled when PLC-debugging is off.
	Will cause a flood of PLC-operations and debug outputs.
	Only has any effect, if plcCompilationEnabled is enabled."
	
	^ Smalltalk at: #'VMs-Seminar-automaticallySetFlag' ifAbsent: [ false ]! !

!PLCConfiguration class methodsFor: 'misc' stamp: 'ag 1/7/2014 17:12'!
cleanMethods
	"Disable very long jumps and answer how many methods have been recompiled.
	Methods with PLC stubs might stick around."
	
	| methods |
	self disableLongJumpCompilation.
	self disablePlcCompilation.
	methods := self methodsWithLongJump.
	methods do: [ :mt |
		mt methodClass recompile: mt selector ].
	^ methods size! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/14/2014 11:47'!
clearPLCFlags
	
	(CompiledMethod allInstances select: #flag) do: #clearFlag! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/19/2014 17:13'!
disableAll
	
	self disableLongJumpCompilation.
	self disablePlcCompilation.
	self disableAutomaticallySetFlag.! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/19/2014 17:09'!
disableAutomaticallySetFlag
	"self disableaAutomaticallySetFlag"
	
	^ Smalltalk globals removeKey: #'VMs-Seminar-automaticallySetFlag' ifAbsent: [ "nothing" ]! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/7/2014 16:56'!
disableLongJumpCompilation
	"self disableLongJumpCompilation"
	
	^ Smalltalk globals removeKey: #'VMs-Seminar-veryLongJumpCompilationEnabled' ifAbsent: [ "nothing" ]! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/7/2014 16:56'!
disablePlcCompilation
	"self disablePlcCompilation"
	
	^ Smalltalk globals removeKey: #'VMs-Seminar-plcCompilationEnabled' ifAbsent: [ "nothing" ]! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/19/2014 17:12'!
enableAll
	
	self enableLongJumpCompilation.
	self enablePlcCompilation.
	self enableAutomaticallySetFlag.! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/19/2014 17:10'!
enableAutomaticallySetFlag
	"self enableAutomaticallySetFlag"
	
	^ Smalltalk at: #'VMs-Seminar-automaticallySetFlag' put: true! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/7/2014 16:32'!
enableLongJumpCompilation
	"self enableLongJumpCompilation"
	
	^ Smalltalk at: #'VMs-Seminar-veryLongJumpCompilationEnabled' put: true! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/7/2014 16:41'!
enablePlcCompilation
	"self enablePlcCompilation"
	
	^ Smalltalk at: #'VMs-Seminar-plcCompilationEnabled' put: true! !

!PLCConfiguration class methodsFor: 'fixing special objects array' stamp: 'ag 1/14/2014 14:25'!
fixSpecialObjectsArray
	"This should be done before opening an image with a PLCInterpreter, otherwise it will not be able to handle PLCs."
	"self fixSpecialObjectsArray"
	
	Smalltalk specialObjectsArray at: 47 put: PLCStruct.! !

!PLCConfiguration class methodsFor: 'misc' stamp: 'ag 1/16/2014 13:01'!
messagesInMethod: method
	"This is copied from #messages in CompiledMethod, but instead of a Set,
	we collect the messages into a OrderedCollection to count the actual callsites."
	
	| messages scanner |
	messages := OrderedCollection new.
	scanner := InstructionStream on: method.
	scanner
		scanFor: 
			[:x | 
			scanner addSelectorTo: messages.
			false	"keep scanning"].
	^ messages! !

!PLCConfiguration class methodsFor: 'misc' stamp: 'ag 1/7/2014 17:16'!
methodsWithLongJump
	
	^ CompiledMethod allInstances
		select: [ :mt | | index |
			index := mt indexOf: 126 startingAt: mt initialPC ifAbsent: [ 0 ].
			index > 0 and: [ index < mt endPC ] ]! !

!PLCConfiguration class methodsFor: 'misc' stamp: 'ag 1/14/2014 11:47'!
methodsWithPLCFlag
	
	^ CompiledMethod allInstances count: #flag! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/7/2014 16:34'!
plcCompilationEnabled
	"PLC-compilation affects two separate places in the compiler,
	which both have to be enabled at the same time."
	
	^ Smalltalk at: #'VMs-Seminar-plcCompilationEnabled' ifAbsent: [ false ]! !

!PLCConfiguration class methodsFor: 'misc' stamp: 'ag 1/20/2014 10:18'!
printStack
	
	| c |
	c := thisContext.
	Transcript cr; show: ' ===== STACK ===== '.
	[ c isNil ] whileFalse: [
		c := c sender.
		Transcript cr.
		c printOn: Transcript ].! !

!PLCConfiguration class methodsFor: 'misc' stamp: 'ag 1/20/2014 12:30'!
recompileAllMethodWithPLCs
	
	self enablePlcCompilation.
	(Smalltalk allClasses copyWithoutAll: Behavior withAllSuperclasses)
	do: [ :cl | | selectors |
		Transcript cr; show: 'Recompiling class ', cl name.
		selectors := cl selectors.
		selectors do: [ :sel |
			(cl >> sel) flag
				ifTrue: [ Transcript nextPut: $-; flush ]
				ifFalse: [
					(cl >> sel) canHandlePlcLiterals
						ifTrue: [
							cl recompile: sel.
							Transcript nextPut: $.; flush ]
						ifFalse: [ Transcript nextPut: $x; flush ] ] ] ].! !

!PLCConfiguration class methodsFor: 'misc' stamp: 'ag 1/15/2014 11:38'!
regenerateVM
	"Grab the first (should be the only) VMMaker instance and tell it to regenerate the interp.c file."
	
	| vm |
	Smalltalk garbageCollect.
	vm := VMMaker allSubInstances first.
	(vm coreVMDirectory fileExists: vm interpreterFilename)
		ifTrue: [ vm coreVMDirectory deleteFileNamed: vm interpreterFilename ].
	vm generateInterpreterFile.! !

!PLCConfiguration class methodsFor: 'fixing special objects array' stamp: 'ag 1/14/2014 14:30'!
unfixSpecialObjectsArray
	"self unfixSpecialObjectsArray"
	
	Smalltalk specialObjectsArray at: 47 put: nil.! !

!PLCConfiguration class methodsFor: 'compilation' stamp: 'ag 1/7/2014 16:32'!
veryLongJumpCompilationEnabled
	
	^ Smalltalk at: #'VMs-Seminar-veryLongJumpCompilationEnabled' ifAbsent: [ false ]! !

Object subclass: #Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMs-Seminar'!

!Test methodsFor: 'as yet unclassified' stamp: 'vk 1/7/2014 14:02'!
test
	"return true"
	| value |
	value := 1.
	value := value increment.
	^ value! !

Object subclass: #VmBenchmarks
	instanceVariableNames: 'random'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMs-Seminar'!

!VmBenchmarks class methodsFor: 'polymorphic' stamp: 'ag 12/6/2013 11:07'!
a
	^ 1! !

!VmBenchmarks class methodsFor: 'polymorphic' stamp: 'ag 12/6/2013 11:07'!
b
	^ 2! !

!VmBenchmarks class methodsFor: 'bench' stamp: 'ag 12/6/2013 12:39'!
bench: t1 forSeconds: t2 
	| t3 t4 t5 |
	t3 := 0.
	t5 := Time millisecondClockValue + (t2 * 1000).
	t4 := Time millisecondClockValue.
	[Time millisecondClockValue > t5]
		whileFalse: [t1 value.
			t3 := t3 + 1].
	t5 := Time millisecondClockValue.
	^ (t3 * 1000 / (t5 - t4)) asFloat! !

!VmBenchmarks class methodsFor: 'bench' stamp: 'ag 12/6/2013 12:42'!
bench: block forSeconds: seconds times: number
	"Will measure how often block can be executed per second. Will run this <number> times.
	The total runtime of this is seconds * number.
	Example:
	VmBenchmarks bench: [ VmBenchmark benchFibonacci ] forSeconds: 5 times: 10
	This will run for 50 seconds."
	
	| times |
	times := Set new.
	number timesRepeat: [ times add: (self bench: block forSeconds: seconds) ].
	^ times average! !

!VmBenchmarks class methodsFor: 'fibonacci' stamp: 'ag 12/6/2013 12:39'!
benchFibonacci
	^ self fibonacci: 1000! !

!VmBenchmarks class methodsFor: 'polymorphic' stamp: 'ag 12/6/2013 11:07'!
benchPolymorphic
	1000 timesRepeat: [ self a + self b + self c + self d + self e + self f ]! !

!VmBenchmarks class methodsFor: 'polymorphic' stamp: 'ag 12/6/2013 11:07'!
c
	^ 3! !

!VmBenchmarks class methodsFor: 'polymorphic' stamp: 'ag 12/6/2013 11:07'!
d
	^ 4! !

!VmBenchmarks class methodsFor: 'polymorphic' stamp: 'ag 12/6/2013 11:07'!
e
	^ 5! !

!VmBenchmarks class methodsFor: 'polymorphic' stamp: 'ag 12/6/2013 11:07'!
f
	^ 6! !

!VmBenchmarks class methodsFor: 'fibonacci' stamp: 'ag 12/6/2013 10:41'!
fibonacci: aNumber
	aNumber < 0 ifTrue: [^0].
	aNumber < 2 ifTrue: [^aNumber].
	^ aNumber + (self fibonacci: aNumber - 1)! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:33'!
allSelectors: aNumber
	
	^ (0 to: aNumber) collect: [ :num | ('test', num asString) asSymbol ]! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:46'!
benchSyntheticalClassesWith20Methods
	
	| classes |
	classes := self createClasses: 20 withMethods: 20.
	classes do: [ :class |
		self invoke20MethodsOn: class ].! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:47'!
benchSyntheticalClassesWith3Methods
	
	| classes |
	classes := self createClasses: 20 withMethods: 3.
	classes do: [ :class |
		self invoke3MethodsOn: class ].! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:35'!
createClass: name
	
	^ Object subclass: name
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'VMs-Seminar-Tests'! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:35'!
createClasses: aNumber
	
	^ (1 to: aNumber) collect: [ :num |
		self createClass: #'VmsSeminarGeneratedTestClass', num asString ]! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:37'!
createClasses: classes withMethods: methods
	
	^ (self createClasses: classes)
		collect: [ :cl |
			self createMethods: methods in: cl.
			cl ]! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:30'!
createMethod: selector in: class
	
	^ class compile: (selector asString, ' ^ ', random nextInt: 1000000)! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:33'!
createMethods: aNumber in: class
	
	^ (0 to: aNumber) collect: [ :num |
		self createMethod: 'test', aNumber asString in: class ].! !

!VmBenchmarks methodsFor: 'initialize' stamp: 'ag 1/13/2014 14:27'!
initialize
	
	super initialize.
	random := Random new.
	classNumber := 0.! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:45'!
invoke20MethodsOn: class
	
	class new
		test1;
		test2;
		test3;
		test4;
		test5;
		test6;
		test7;
		test8;
		test9;
		test10;
		test11;
		test12;
		test13;
		test14;
		test15;
		test16;
		test17;
		test18;
		test19;
		test20.! !

!VmBenchmarks methodsFor: 'bench - synthetical classes' stamp: 'ag 1/13/2014 14:47'!
invoke3MethodsOn: class
	
	class new
		test1;
		test2;
		test3.! !

!MethodNode methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 11:00'!
finalizePLCCompilationOf: method withLiterals: literals
	
	PLCConfiguration plcCompilationEnabled ifFalse: [ ^ self ].
	literals do: [ :lit |
		(lit isKindOf: PLCStruct) ifTrue: [ lit compiledMethod: method ] ].
	"Let the VM know this is a PLC method."
	PLCConfiguration automaticallySetFlag ifTrue: [ method setFlag ].! !

!MethodNode methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 10:15'!
generate: trailer using: aCompiledMethodClass
	"The receiver is the root of a parse tree. Answer an instance of aCompiledMethodClass.
	 The argument, trailer, is arbitrary but is typically either the reference to the source code
	 that is stored with every CompiledMethod, or an encoding of the method's temporary names."

	| primErrNode blkSize nLits literals stack method |
	self generate: trailer
		using: aCompiledMethodClass
		ifQuick:
			[:m |
			  m	literalAt: 2 put: encoder associationForClass;
				properties: properties.
			^m].
	primErrNode := self primitiveErrorVariableName ifNotNil:
						[encoder fixTemp: self primitiveErrorVariableName].
	encoder supportsClosureOpcodes ifTrue:
		[self ensureClosureAnalysisDone.
		 encoder rootNode: self. "this is for BlockNode>>sizeCodeForClosureValue:"].
	blkSize := (block sizeCodeForEvaluatedValue: encoder)
				+ (primErrNode
					ifNil: [0]
					ifNotNil: [primErrNode sizeCodeForStore: encoder "The VM relies on storeIntoTemp: (129)"]).
	method := aCompiledMethodClass
				newBytes: blkSize
				trailerBytes: trailer 
				nArgs: arguments size
				nTemps: (encoder supportsClosureOpcodes
							ifTrue: [| locals |
									locals := arguments,
											  temporaries,
											  (primErrNode
												ifNil: [#()]
												ifNotNil: [{primErrNode}]).
									encoder
										noteBlockExtent: block blockExtent
										hasLocals: locals.
									locals size]
							ifFalse: [encoder maxTemp])
				nStack: 0
				nLits: (nLits := (literals := encoder allLiterals) size)
				primitive: primitive.
	nLits > 255 ifTrue:
		[ "Too many literals -> retry compilation without PLCs. Will most likely fix the issue."
		PLCConfiguration plcCompilationEnabled ifTrue: [
			PLCConfiguration disablePlcCompilation.
			^ self generate: trailer using: aCompiledMethodClass ].
		^self error: 'Too many literals referenced'].
	1 to: nLits do: [:lit | method literalAt: lit put: (literals at: lit)].
	encoder streamToMethod: method.
	stack := ParseStack new init.
	primErrNode ifNotNil: [primErrNode emitCodeForStore: stack encoder: encoder].
	stack position: method numTemps.
	block emitCodeForEvaluatedValue: stack encoder: encoder. 
	stack position ~= (method numTemps + 1) ifTrue:
		[^self error: 'Compiler stack discrepancy'].
	encoder methodStreamPosition ~= (method size - trailer size) ifTrue:
		[^self error: 'Compiler code size discrepancy'].
	method needsFrameSize: stack size - method numTemps.
	method properties: properties.
	self finalizePLCCompilationOf: method withLiterals: literals.
	^ method! !

Array variableSubclass: #PLCStruct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMs-Seminar'!

!PLCStruct class methodsFor: 'constants' stamp: 'ag 1/19/2014 16:55'!
compiledMethodIndex
	
	^ 2! !

!PLCStruct class methodsFor: 'constants' stamp: 'ag 1/19/2014 16:08'!
defaultNumberOfEntries
	
	^ 3! !

!PLCStruct class methodsFor: 'instance creation' stamp: 'ag 1/19/2014 16:08'!
defaultSize
	"These numbers correspond to constants in PLCInterpreter."
	
	^ self metaInfoEntries + (self defaultNumberOfEntries * self pointersPerEntry)! !

!PLCStruct class methodsFor: 'constants' stamp: 'ag 1/19/2014 15:08'!
firstEntryIndex
	
	^ self metaInfoEntries + 1! !

!PLCStruct class methodsFor: 'cleanup' stamp: 'ag 1/20/2014 15:22'!
flushAll
	
	PLCStruct allInstances do: #flushAll.! !

!PLCStruct class methodsFor: 'instance creation' stamp: 'ag 1/19/2014 16:14'!
forSelector: selector
	
	^ (self new: self defaultSize)
		selector: selector;
		yourself! !

!PLCStruct class methodsFor: 'constants' stamp: 'ag 1/19/2014 16:55'!
messageSelectorIndex
	
	^ 1! !

!PLCStruct class methodsFor: 'constants' stamp: 'ag 1/19/2014 15:08'!
metaInfoEntries
	"Stored at the beginning of a PLCStruct: selector, compiledMethod"
	
	^ 2! !

!PLCStruct class methodsFor: 'cleanup' stamp: 'ag 1/19/2014 17:57'!
methodsWithEnabledPLC
	
	^ self methodsWithPLC select: #flag! !

!PLCStruct class methodsFor: 'cleanup' stamp: 'ag 1/19/2014 18:11'!
methodsWithPLC
	
	^ (self allInstances
		collect: #compiledMethod
		thenSelect: [ :mt | mt selector isDoIt not ])
		asSet! !

!PLCStruct class methodsFor: 'constants' stamp: 'ag 1/19/2014 15:05'!
pointersPerEntry
	"Values kept in a single entry of a PLC:
	- lookup class
	- method
	- newMethod
	- primitiveIndex"
	
	^ 4! !

!PLCStruct class methodsFor: 'cleanup' stamp: 'ag 1/19/2014 15:17'!
stripAllPLCs
	
	self methodsWithPLC do: #recompileWithoutPLC.! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/19/2014 16:56'!
cachedClasses
	
	| classes |
	classes := OrderedCollection new.
	self classesDo: [ :cl | classes add: cl ].
	^ classes! !

!PLCStruct methodsFor: 'iterating' stamp: 'ag 1/19/2014 15:09'!
classIndicesDo: aBlock
	"Evaluate aBlock with every index of this PLCStruct containing a class."
	
	^ self class firstEntryIndex to: self size by: self class pointersPerEntry do: aBlock! !

!PLCStruct methodsFor: 'iterating' stamp: 'ag 1/17/2014 17:46'!
classesDo: aBlock
	"Evaluate aBlock with every class contained in this PLCStruct."
	
	^ self classIndicesDo: [ :i | aBlock value: (self at: i) ]! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/19/2014 16:56'!
compiledMethod
	
	^ self at: self class compiledMethodIndex! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/19/2014 16:56'!
compiledMethod: method
	
	self at: self class compiledMethodIndex put: method.! !

!PLCStruct methodsFor: 'flushing' stamp: 'ag 1/20/2014 15:21'!
flushAll
	
	self classIndicesDo: [ :index |
		self invalidateEntry: index ].! !

!PLCStruct methodsFor: 'flushing' stamp: 'ag 1/17/2014 17:48'!
flushMethod: mt
	
	self selector = mt selector ifFalse: [ ^ self ].
	self classIndicesDo: [ :i |
		mt methodClass == (self at: i)
			ifTrue: [ ^ self invalidateEntry: i ] ].! !

!PLCStruct methodsFor: 'private' stamp: 'ag 1/19/2014 16:48'!
hasLiteral: literal
	"A PLCStruct does not contain any other literals."
	
	^ false! !

!PLCStruct methodsFor: 'flushing' stamp: 'ag 1/20/2014 15:21'!
invalidateEntry: index
	"Just leave the ByteArray located at (index + 1) filled with old information.
	It will be overwritten later."
	
	self at: index put: nil.! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/20/2014 11:27'!
isFull
	
	^ (self cachedClasses includes: nil) not! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/20/2014 19:26'!
isMegamorphic
	
	^ self numberOfEntries = 0! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/20/2014 19:25'!
isMonomorphic
	
	^ self numberOfEntries = 1! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/20/2014 19:26'!
isPolymorphic
	
	^ self numberOfEntries > 1! !

!PLCStruct methodsFor: 'comparing' stamp: 'ag 1/19/2014 16:10'!
literalEqual: otherObject
	"Every PLCStructs is a different literal, regardless of it's contents."
	
	^ self == otherObject! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/19/2014 15:08'!
numberOfEntries
	
	^ (self size - self class metaInfoEntries) // self class pointersPerEntry! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/19/2014 16:56'!
selector
	
	^ self at: self class messageSelectorIndex! !

!PLCStruct methodsFor: 'accessing' stamp: 'ag 1/19/2014 16:56'!
selector: selector
	
	self at: self class messageSelectorIndex put: selector.! !

!PLCStruct methodsFor: 'cleanup' stamp: 'ag 1/19/2014 15:15'!
stripPLCFromMethod
	
	self compiledMethod flag ifTrue: [
		self compiledMethod recompileWithoutPLC ].! !

ClassicObjectMemory subclass: #PLCObjectMemory
	instanceVariableNames: 'classPlcStruct plcStructClassAvailable'
	classVariableNames: 'ClassPLCStruct'
	poolDictionaries: ''
	category: 'VMs-Seminar'!

!PLCObjectMemory commentStamp: '<historical>' prior: 0!
ClassicObjectMemory represents the original Squeak object memory used by Interpreter. Some methods from ObjectMemory are modified or extended in other object memory implementations such as NewObjectMemory. The original implementations of these methods have been moved to ClassicObjectMemory in order to retain the original Squeak object memory while enabling variations such as NewObjectMemory to be implemented as subclasses of ObjectMemory.!

!PLCObjectMemory class methodsFor: 'translation' stamp: 'ag 1/14/2014 13:55'!
declareCVarsIn: aCCodeGenerator
	
	super declareCVarsIn: aCCodeGenerator.
	self declareCAsOop: { #classPlcStruct. #plcStructClassAvailable } in: aCCodeGenerator.! !

!PLCObjectMemory class methodsFor: 'initialization' stamp: 'ag 1/13/2014 20:34'!
initializeSpecialObjectIndices
	
	super initializeSpecialObjectIndices.
	ClassPLCStruct := 46.! !

!PLCObjectMemory class methodsFor: 'translation' stamp: 'ag 1/13/2014 20:19'!
interpreterClass
	
	^ PLCInterpreter! !

!PLCObjectMemory methodsFor: 'plc' stamp: 'ag 1/13/2014 21:05'!
classPLCStruct
	
	<inline: true>
	^ classPlcStruct! !

!PLCObjectMemory methodsFor: 'plc' stamp: 'ag 1/14/2014 13:26'!
hasPLCStruct
	"This is called very frequently. Use an extra variabl to store this boolean."
	
	<inline: true>
	^ plcStructClassAvailable! !

!PLCObjectMemory methodsFor: 'initialization' stamp: 'ag 1/17/2014 18:37'!
initializeObjectMemory: bytesToShift
	
	super initializeObjectMemory: bytesToShift.
	classPlcStruct := self splObj: ClassPLCStruct.
	plcStructClassAvailable := classPlcStruct ~= nilObj.
	
	"Notify user that PLCStruct is not contained at the expected index in the specialObjectsArray."
	plcStructClassAvailable ifFalse: [
		interpreter
			print: 'PLCStruct not found. Execute ''PLCConfiguration fixSpecialObjectsArray'', save image and restart VM.';
			cr ].! !

!PLCObjectMemory methodsFor: 'plc' stamp: 'ag 1/20/2014 11:20'!
isOldNonIntegerOop: oop
	
	^ self oop: oop isLessThan: youngStart! !

!Encoder methodsFor: '*VMs-Seminar' stamp: 'ag 1/20/2014 10:32'!
encodeSelector: selector
	"Do not reuse SelectorNode instances.
	Required to assign a separate PLC literal for each call site.
	See SelectorNode >> #sizeCode:args:super:, usage of plcIndex."
	
	^(self
		name: selector
		key: selector
		class: SelectorNode
		type: SendType
		set: selectorSet)
			copyWithoutPlcLiteral! !
PLCInterpreter initialize!
